function ShowGCD_Onload(self) 
	self:RegisterEvent('SPELL_UPDATE_COOLDOWN')
	print("ShowGCD loaded."); 
end 

local referenceSpells = {
	49892,			-- Death Coil (Death Knight)
	66215,			-- Blood Strike (Death Knight)
	1978,			-- Serpent Sting (Hunter)
	585,			-- Smite (Priest)
	19740,			-- Blessing of Might (Paladin)
	172,			-- Corruption (Warlock)
	5504,			-- Conjure Water (Mage)
	772,			-- Rend (Warrior)
	331,			-- Healing Wave (Shaman)
	1752,			-- Sinister Strike (Rogue)
	5176,			-- Wrath (Druid)
}

local GetTime = GetTime
local BOOKTYPE_SPELL = BOOKTYPE_SPELL
local GetSpellCooldown = GetSpellCooldown
local spellId = nil

local FindSpellId = function()
	local FindInSpellbook = function(spell)
		for tab = 1, 4 do
			local _, _, offset, numSpells = GetSpellTabInfo(tab)
			for i = (1+offset), (offset + numSpells) do
				local bspell = GetSpellName(i, BOOKTYPE_SPELL)
				if (bspell == spell) then
					return i   
				end
			end
		end
		return nil
	end

	for _, lspell in pairs(referenceSpells) do
		local na = GetSpellInfo (lspell)
		local x = FindInSpellbook(na)
		if x ~= nil then
			return lspell
		end
	end

	return nil
end

function ShowGCD_OnEvent(self, event, ...)
	if not spellId then
		spellId = FindSpellId()
		if not spellId then
			print ("ShowGCD: Unable to find reference spell! Aborting.")
			return
		end
	end

	local name = self:GetName()
	local cooldown = _G[name.."Cooldown"]
	if (cooldown) then
		local start, duration, enable = GetSpellCooldown(spellId)
		CooldownFrame_SetTimer(cooldown, start, duration, enable)
		if (start == 0) then -- interrupted
			self:Hide()
			self:SetScript('OnUpdate', nil)		
		else
			self:Show()
			cooldown:SetCooldown(start, duration)
			local endTime = start + duration
			if (not self:GetScript('OnUpdate')) then
				self:SetScript('OnUpdate', function(self, elapsed)
					if (endTime < GetTime()) then
						self:Hide()
						self:SetScript('OnUpdate', nil)
					end
				end)
			end
		end
	end
end
